﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using MPS;


namespace WagoWS2012
{
    public partial class Form1 : Form
    {
        TcpClient tcpClientWAGO = new TcpClient();      //Klasse-->  Stellt Clientverbindungen für TCP-Netzwerkdienste bereit
        NetworkStream netStreamWAGO;                    //Klasse-->  Stellt den zugrunde liegenden Datenstream für den Netzwerkzugriff bereit
        TMultimediaTimer MMTimer1;                      //Klasse-->  MultimediaTimer

        float value1 ,value2;                           // Variable zur Verwendung in mehreren Methoden
       
        public Form1()
        {
            InitializeComponent();
            MMTimer1 = new TMultimediaTimer(null);
            MMTimer1.OnTimer = EventVomMMTimer;
            MMTimer1.Interval = 10;  //10ms
        }
        
        // Verbindung herstellen mit WAGO Client
        private void btVerbinden_Click_1(object sender, EventArgs e)
        {
            try
            {
                if (!tcpClientWAGO.Connected)
                {
                  tcpClientWAGO.Connect("192.168.0.2", 502);
                  // tcpClient.Connect("193.175.124.132", 502);
                    if (tcpClientWAGO.Connected) toolStripStatusLabel1.Text = "Wago is connected";
                }
                else MessageBox.Show("Verbindung besteht bereits", "TCP Connection Info", MessageBoxButtons.OK);
            }
            catch (SocketException)
            {
                MessageBox.Show("Verbindungsaufbau nicht möglich", "TCP Connection Error", MessageBoxButtons.OK);
            }
        }


        //  Aufruf von: Senden eines Wortes an die WAGO Klemme
        private void btDA0Senden_Click(object sender, EventArgs e)
        {
            DatenWortSenden((double)nUD_DA0Senden.Value);
        }

        //  Aufruf von: Lesen von zwei Worten aus der WAGO Klemme
        private void button1_Click_1(object sender, EventArgs e)
        {
            DatenWortLesen(ref value1, ref value2);
            tB_AD_0.Text = value1.ToString();
            tB_AD_1.Text = value2.ToString();
        }

        // Start MultimediaTimer
        private void btStartMMTimer1_Click(object sender, EventArgs e)
        {
            MMTimer1.Enable();
        }

        // 
        void EventVomMMTimer(TMultimediaTimer sender)
        {
            DatenWortLesen(ref value1, ref value2);
            DatenWortSenden(value1);
        }
        
        
        private void timer1_Tick(object sender, EventArgs e)
        {
            tB_AD_0.Text = value1.ToString();
            tB_AD_1.Text = value2.ToString();
        }

        //   Senden eines Wortes an die WAGO Klemme --> FC6 (FunctionCode0x06) WriteSingleRegister
        private void DatenWortSenden(double DA_Wert)
        {
            try
            {
                netStreamWAGO = tcpClientWAGO.GetStream();  // Gibt den für das Senden und Empfangen von Daten verwendeten NetworkStream zurück.
                if (netStreamWAGO.CanWrite)                 // Ruft einen Wert ab, der angibt, ob der NetworkStream Schreibvorgänge unterstützt. 
                {

                    byte[] sendBytes = new byte[12];
                    // MAP-Header (Modbus Application Protocol Header)
                    sendBytes[0] = 0x00;        // transaction identifier high byte 
                    sendBytes[1] = 0x00;        // transaction identifier low byte 
                    sendBytes[2] = 0x00;        // protocol identifier high byte
                    sendBytes[3] = 0x00;        // protocol identifier low byte
                    sendBytes[4] = 0x00;        // length high byte:  = Size of Modbus PDU
                    sendBytes[5] = 0x06;        // length low byte :  + unit identifier byte
                    sendBytes[6] = 0x00;        // unit identifier
                    // PDU (Protocol Data Unit)
                    sendBytes[7] = 0x06;        // FunctionCode 6: Write Single Registers
                    sendBytes[8] = 0x00;        // reference number high byte
                    sendBytes[9] = (byte)nUD_DA_Auswahl.Value;        // reference number low byte
                    sendBytes[10] = (byte)((int)(DA_Wert * 0x7fff / 10) >> 8);   //Register Value 1 high byte
                    sendBytes[11] = (byte)(DA_Wert * 0x7fff / 10);               //Register Value 1 low byte

                    netStreamWAGO.Write(sendBytes, 0, sendBytes.Length);    //Schreibt Daten in den NetworkStream
                }
            }
            catch (Exception)
            {
                MessageBox.Show("Request nicht möglich.", "TCP Connection Error", MessageBoxButtons.OK);
            }

            try
            {   
                netStreamWAGO = tcpClientWAGO.GetStream();  // Gibt den für das Senden und Empfangen von Daten verwendeten NetworkStream zurück.
                if (netStreamWAGO.CanRead)                  // Ruft einen Wert ab, der angibt, ob der NetworkStream Schreibvorgänge unterstützt. 
                {
                    byte[] readBytes = new byte[tcpClientWAGO.ReceiveBufferSize];
                    // Lesen des Response  >Modbus/TCP:response<  Anwort!   Werte verarbeiten 
                    netStreamWAGO.Read(readBytes, 0, (int)tcpClientWAGO.ReceiveBufferSize);     //Liest Daten aus dem NetworkStream
                    if (readBytes[7] == 0x85) MessageBox.Show("ErrorCode 0x85.", "TCP Connection Error", MessageBoxButtons.OK);
                }   // Error Code in Byte 7, Exception Code in Byte 8
            }
            catch (Exception)
            {
                MessageBox.Show("Response nicht möglich.", "TCP Connection Error", MessageBoxButtons.OK);
            }
        }

        //   Lesen eines Wertes von  der WAGO Klemme --> FC4 (FunctionCode0x04) ReadInputRegister
        //                                     oder  --> FC3 (FunctionCode0x04) ReadHoldingRegister (gleiche Funktion)
        //   HIER werden jetzt beide Wörter gleichzeitig ausgelesen. Soll nur ein Wort (Wert) ausgeledesn werden,
        //   dann "word count = 1" und mit "reference number" auf gewünschten Wert zeigen

        private void DatenWortLesen(ref float AD_0,ref float AD_1 )
        {
             try
            {
                netStreamWAGO = tcpClientWAGO.GetStream();
                if (netStreamWAGO.CanWrite)
                {
                    byte[] sendBytes = new byte[12];
                    // MAP-Header (Modbus Application Protocol Header)
                    sendBytes[0] = 0x00;        // transaction identifier high byte 
                    sendBytes[1] = 0x00;        // transaction identifier low byte 
                    sendBytes[2] = 0x00;        // protocol identifier high byte
                    sendBytes[3] = 0x00;        // protocol identifier low byte
                    sendBytes[4] = 0x00;        // length high byte:  = Size of Modbus PDU
                    sendBytes[5] = 0x06;        // length low byte :  + unit identifier byte
                    sendBytes[6] = 0x00;        // unit identifier
                    // PDU (Protocol Data Unit)
                    sendBytes[7] = 0x04;        // FunctionCode: Read Input Registers
                    sendBytes[8] = 0x00;        // reference number high byte
                    sendBytes[9] = 0x00;        // reference number low byte
                    sendBytes[10] = 0x00;       // word count high byte
                    sendBytes[11] = 0x02;       // word count low byte HIER: beide Werte werden gelesen
                    // Senden des Requets  >Modbus/TCP:query<  Anfrage? Werte Abfragen!
                    netStreamWAGO.Write(sendBytes, 0, sendBytes.Length);
                }
            }
            catch (Exception)
            {
                MessageBox.Show("Request nicht möglich.", "TCP Connection Error", MessageBoxButtons.OK);
            }

            try
            {
                netStreamWAGO = tcpClientWAGO.GetStream();
                if (netStreamWAGO.CanRead)
                {
                    byte[] bytes = new byte[tcpClientWAGO.ReceiveBufferSize];
                    netStreamWAGO.Read(bytes, 0, (int)tcpClientWAGO.ReceiveBufferSize);
                    AD_0 = (float)(((sbyte)bytes[9]) << 8 | bytes[10]) * 10 / 0x7fff;
                    AD_1 = (float)(((sbyte)bytes[11]) << 8 | bytes[12]) * 10 / 0x7fff;
                    // Aubau von Error und Exception Code genauso wie beim Schreiben
                    // wird hier nicht ausgewertet.
                }
            }
            catch (Exception)
            {
                MessageBox.Show("Response nicht möglich.", "TCP Connection Error", MessageBoxButtons.OK);
                
            }
           
        }

    }
}
